Description

| get a crashin

void UncompressHuffman(const std::vector<short>& adc,
std::vector<short>  &uncompressed)

from lardata/RawData/raw.cxx. | believe it is because | have passed an empty vector in my call to

void Uncompress (const std::vectoré&lt;shorté&gt; & adc,

std::vector&lt;short&gt; &uncompressed,
int &pedestal,
raw: :Compress_t compress)

with compress = raw::kHuffman.
and UncompressHuffman tries to fill uncompress without allocating space:
uncompressed[0] = adc[0];

| believe UncompressHuffman (or Uncompress) should first ensure the vector is of appropriate size.

History

#1 - 02/04/2016 05:39 PM - Jonathan Insler

David Adams wrote:
I getacrashin

void UncompressHuffman(const std::vector<short>& adc,
std::vector<short>  &uncompressed)

from lardata/RawData/raw.cxx. | believe it is because | have passed an empty vector in my call to
void Uncompress(const std::vector<short>& adc,

std::vector<short> ~ &uncompressed,

int &pedestal,

raw::Compress_t compress)

with compress = raw::kHuffman.

and UncompressHuffman tries to fill uncompress without allocating space:

uncompressed? = adc’;

| believe UncompressHuffman (or Uncompress) should first ensure the vector is of appropriate size.

This problem predates my involvement with raw.cxx. It looks like the original UncompressHuffman function doesn't resize std::vector<short>

uncompressed, so it must be delivered to raw.cxx as the proper size.

#2 - 03/04/2016 10:57 AM - Gianluca Petrillo

- Status changed from New to Rejected
The function raw::Uncompress() expects the buffer to be fully allocated. Good old C style (or not so good).
Of course, that is documented nowhere.

I will not change this behaviour, since the uncompress function does not necessarily know the size of the uncompressed data before inflating is
completed. Progressively expanding the buffer can be inefficient.

On the other end, the caller one, if the buffer comes from a raw::RawDigit the sample size is known and the caller can resize the buffer to the
expected final size.

#3 - 03/04/2016 11:39 AM - Gianluca Petrillo

| have pushed (develop branch in lardata) inline documentation to Uncompress() and Compress() functions, that are the functions that LArSoft
originally supported.
| don't know enough of the current custom to personally support the others.

| believe the whole uncompression system (and maybe the compression too?) should be revisited, formalized and updated.

There are already some utility classes in the event display that handle (in an attempted "smart" way) uncompressed data, and we may consider to
promote them, or to write something better.
